"""
Implements endpoints for PT fleet management.
"""
import json
import os
import logging
from flask import Blueprint, send_file
from flask import current_app as app

from app import utils

pt_fleet = Blueprint("pt_fleet", __name__)

logger = logging.getLogger(__name__)

ts_url = app.dotenv["TS_URL"]
storage_url = app.dotenv["STORAGE_URL"]
city = app.dotenv["URBANITE_CITY"]
data_dir = f"{app.dotenv['DATA_DIR']}/{app.dotenv['URBANITE_CITY']}"


@pt_fleet.route("/dss/pt-fleet/<int:sim_id>")
def get_required_vehicles_drivers(sim_id):
    sim_dir = utils.get_sim_dir_names([sim_id])[0]
    path = (
        f"{data_dir}/simulations/{sim_id}/results/{sim_dir}/pt_fleet_requirements.json"
    )
    if not os.path.exists(path):
        network, events = utils.get_network_and_events(sim_id)
        required = events.count_pt_vehicles_drivers()
        with open(path, "w", encoding="utf-8") as fd:
            json.dump(required, fd)
    return send_file(path)
